//+------------------------------------------------------------------+
//|                                  _OrderSend-Market - 3 Exits.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "SG"
#property link      ""

extern string sOrderType = "----Market Order Type - Buy/Sell----";
extern bool BuyOrder  = true;
extern bool SellOrder = false;

extern string sLots = "----Enter Number of Lots/divisible by 3----";
extern int    Lots     = 3;                                        //Number of lots to open order with

//-----Use Stop Loss value to calculate TP Targets

extern string sValues = "----TP1 = 1:1 , TP2 = 2:1 , TP3 = Trail----";
extern double Limit        = 1.272;               //Limit Price                       Long - 2010/09/09 - E/U - 1.272 Limit / 1.2635 SL  / 120 Trail / 1.2918 TP2
extern double StopLoss     = 1.2635;               //Initial StopLoss Value
extern double TrailingStop = 120.00;               //Trailing stop after TP2

extern string OpenTP2 = "---Enter TP2 Target -- TP1 = 1:1---";
extern double TakeProfit2 = 1.2918;                //enter target TP2 if other than 2:1 , TP3 trail  1.2900


double dPoints;                                             //Point Value
int    iMagic;                                              //Magic # value

bool bDraw   = True;                                        //Draw TP lines 1 time
bool bSetSL  = True;                                        //Set initial SL @ first tick
bool bCalcTP = True;                                        //Set TP targets @ first tick

bool bTP1 = True;                                           //Monitor for TP1, modify SL @ first partial close
bool bTP2 = False;                                          //Monitor for TP2, activate trailing stop after 2nd partial close
bool bTP3 = False;                                          //Trailing Stop only for remaining 1/3

int Ticket, iLots;                                          //return value for OrderLots()
double TP1, TP2;                                            //TP targets

double dSL;                                                 //Initial SL value
double dOpenPrice;                                          //Order openprice function result
double dTrSL;                                               //Trailing stop value
double dTrDiff;                                             //Difference in pips between current stoploss value and target SL value

bool bTP;                                                   //Take Profit confirmation
bool bModSL;                                                //Modify SL confirmation

int iOrderType;
double dPrice;
double dPipDistance;

bool bSLCheck = false;
int Y = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if(BuyOrder == false && SellOrder == false)                           //If no order type selected
      {
       Print("No order type selected to open".);
      }
      
   if(BuyOrder == true && SellOrder == true)                             //If multiple order types selected
      {
       Print("Buy & Sell order selected.  Only select 1 type.");
      }
      
   if((BuyOrder == true && SellOrder == false) || (BuyOrder == false && SellOrder == true))     //Correct order selection, send order
      {
         if(BuyOrder == true)
            {
             Print("Buy Stop Limit order selected.");
             iOrderType = 4;
             //dPrice = Ask;
            }
         if(SellOrder == true)
            {
             Print("Sell Stop Limit order selected.");
             iOrderType = 5;
             //dPrice = Bid;
            }
      
         iMagic = Magic();                                                            //Determine Magic #
         GetPoints();                                                                 //Determine Point value
         string Symb = Symbol();
         
         //int X;
         //X = MessageBox("Sending Buy Order",Symb,1);
         //if(X==1)
         //  {
            Print("Opening Order");
             int bOpen = OrderSend(Symbol(),iOrderType,Lots,Limit,0,0,0,0,iMagic,0,Blue);      //Send order while initializing
         /*    if (bOpen >0)
               {
    
                Print("Order Sent"); 
               }     
            }  */      
      }
  

   ErrorCheck();                                                                //Check for errors

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   
   ObjectDelete("TP1");
   ObjectDelete("TP2");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

      for(int i=1; i<=OrdersTotal(); i++)                                        //cycle through orders 
      {
       if (OrderSelect(i-1,SELECT_BY_POS)==True)                                 //if an order is selected
         {
          if(iMagic!=OrderMagicNumber()) continue;                               //if order magic doesn't match, skip to the next one
          if(OrderType()== 4 || OrderType() == 5) continue;
          
          dOpenPrice = OrderOpenPrice();                                         //order open price       
          iLots   = OrderLots();                                                 //Lots for current selected order
          Ticket = OrderTicket();                                                //Ticket for current selected order

          SetRRSL();                                                             //Modify opened order 1 time, set SL
          
          CalcRRTP();                                                            //Calculate TP values 1 time, 1:1 / 2:1 unless TP2 > 0
          DrawTP();                                                              //Draw TP 1 & TP2 1 time
          
          TP1MonitorRR();                                                        //Wait for price to hit TP1, close 1/3 position/modify SL to breakeven
          TP2MonitorRR();                                                        //After TP1, wait for price to hit TP2, close 1/2/

          TrSL();                                                                //Following 2 hard exits, trail price until close  6
          if(bTP3==true)Y++;                                                     //Wait 1 tick after TP2 to trail SL for new ticket #
         }
      }
          
    ErrorCheck();
  
   return(0);
  }
//+------------------------------------------------------------------+


   int Magic ()
      {
       int X = TimeCurrent();
       return(X);
      }
      
//-------------------------------------------------------------------      
   
   double GetPoints()
      {  
      if (Digits == 3 || Digits == 5) dPoints = Point * 10;
      else dPoints = Point;
      return(dPoints);
      }
      
//-------------------------------------------------------------------  
   
   void ErrorCheck()
      {
       int iError = GetLastError();
       if(iError != 0)
       Alert("Error: ",iError);
      }
      
//-------------------------------------------------------------------  
      
   int GetTicket()
      {
       for(int i=1; i<=OrdersTotal(); i++)                                 //cycle through orders 
       {
        if (OrderSelect(i-1,SELECT_BY_POS)==True)                          //if an order is selected
          {
           if(iMagic!=OrderMagicNumber()) continue;                        //if order magic doesn't match, skip to the next one
           int Ticket = OrderTicket();                                     //Get new ticket #
           //Print("GetTicket() function, New Ticket = ",Ticket);
          }
       }
       return(Ticket);                                                     //Return new ticket #
      }

//-------------------------------------------------------------------   

   void SetRRSL()
      {
      if(bSetSL==True)                                                       //Set initial SL value
         {
          if(OrderType()==0)                                                    //if its a Buy order
           {
            Print("Calculating buy order SL.");
            dSL = StopLoss;                              //Determine SL value     
            bModSL=OrderModify(Ticket,dOpenPrice,NormalizeDouble(dSL,Digits),0,0);                 //Modify open order to add SL value
            if(bModSL==True)                                                    //if order modify success
              {
               Print("SL set @ ",dSL);                                          //confirm success of setting SL
               bModSL = false;                                                  //set ModSL to false
               bSetSL = false;                                                  //close inital SL task, SL has been set
              }
           }
    
          if(OrderType()==1)                                                    //if its a Sell order
            {
             Print("Calculating sell order SL.");
             dSL = StopLoss;                              //Determine SL value     
             bModSL=OrderModify(Ticket,dOpenPrice,NormalizeDouble(dSL,Digits),0,0);                 //Modify open order to add SL value
             if(bModSL==True)                                                    //if order modify success
               {
                Print("SL set @ ",dSL);                                          //confirm success of setting SL
                bModSL = false;                                                  //set ModSL to false
                bSetSL = false;                                                  //close inital SL task, SL has been set
               }                
             }
         }      
      }

//----------------------------------------------------------------------------------

   void CalcRRTP()
      {
       if(bCalcTP==true)                //Only Calculate one time
         {
            if(OrderType()==0)
              {
               dPipDistance = dOpenPrice - dSL;
               Print("dOpenPrice = ",dOpenPrice," dSL = ",dSL," dPipDistance = ",dPipDistance);
               TP1 = dOpenPrice + dPipDistance;                                 //TP1
               TP2 = dOpenPrice + 2*dPipDistance;                               //TP2
               
               if(TakeProfit2>0) TP2 = TakeProfit2;  //For TP2 target other than 2:1
              }
            if(OrderType()==1)
              {
               dPipDistance = dSL - dOpenPrice;
               Print("dOpenPrice = ",dOpenPrice," dSL = ",dSL," dPipDistance = ",dPipDistance);
               TP1 = dOpenPrice - dPipDistance;                                 //TP1
               TP2 = dOpenPrice - 2*dPipDistance;                               //TP2     
               
               if(TakeProfit2>0) TP2 = TakeProfit2;  //For TP2 target other than 2:1                    
              }
            Print("Calculated TP targets.  TP1 = ",TP1," TP2 = ",TP2);
            bCalcTP = false;             
         }
        
      }    
     
//---------------------------------------------------------------------------------------          
      
   void DrawTP()
      {
          if(bDraw==True)
            {
            Print("Drawing initial TP targets.");
            
            ObjectCreate("TP1",OBJ_HLINE,0,0,TP1);                               //Draw TP1
            ObjectSet("TP1",OBJPROP_COLOR,Lime);
            ObjectSet("TP1",OBJPROP_STYLE,3);

            ObjectCreate("TP2",OBJ_HLINE,0,0,TP2);                               //Draw TP2
            ObjectSet("TP2",OBJPROP_COLOR,Lime);
            ObjectSet("TP2",OBJPROP_STYLE,3);
          
            bDraw = False;                                                       //after drawing initial TP targets, close drawing task        
            }         
      }
      
//------------------------------------------------------------------------------------------     

   void TP1MonitorRR()
      {
          if(bTP1==True)                                                         //TP1 Monitor
          {    
          //--Buy order-----------------------------------------------------------
          
            if(OrderType()==0)                                                       //if its a buy order
               {
                if(Bid>=TP1)                                                         //if price hits TP1
                   {
                    bTP = OrderClose(Ticket,iLots/3,Bid,0,Red);                  //CLose 1/3 position
                    if (bTP==True)                                                   //if close success
                       {             
                        Print("Closed 1/3 position @ 1:1 R/R.  ",Lots/3," lots @ TP1.");            //Confirm first TP
                        Print("Modify SL to Break Even for new Ticket # ",GetTicket());            //Verifying new ticket after partial close
                        ObjectDelete("TP1");                                         //delete TP1 line 
                                         
                        dTrSL = dOpenPrice;                                         //calculating new trailing stop level
                        bModSL = OrderModify(GetTicket(),dOpenPrice,NormalizeDouble(dTrSL,Digits),0,0);     //Modify order SL following first partial TP                 

                        if(bModSL==True)                                             //if order modify success
                         {
                          bTP  = False;                                              //reset to default
                          bTP1 = False;                                              //shutdown TP1 cycle
                          bModSL = false;                                            //verify ordermodify, then set to false
                          bTP2 = True;                                               //Open TP2 cycle 
                         }                              
                       }
                   }               
                }
           
           //--Sell order----------------------------------------------------------
                
           if(OrderType()==1)                                                        //if its a sell order
            {
                if(Ask<=TP1)                                                         //if price hits TP1
                   {
                    bTP = OrderClose(Ticket,iLots/3,Ask,0,Red);                       //CLose 1/3 position
                    if (bTP==True)                                                   //if close success
                       {             
                        Print("Closed 1/3 position @ 1:1 R/R.  ",Lots/3," lots @ TP1.");            //Confirm first TP
                        Print("Modify SL to Break Even for new Ticket # ",GetTicket());            //Verifying new ticket after partial close
                        ObjectDelete("TP1");                                         //delete TP1 line 
                                         
                        dTrSL = dOpenPrice;                                         //calculating new trailing stop level
                        bModSL = OrderModify(GetTicket(),dOpenPrice,NormalizeDouble(dTrSL,Digits),0,0);     //Modify order SL following first partial TP                 

                        if(bModSL==True)                                             //if order modify success
                         {
                          bTP  = False;                                              //reset to default
                          bTP1 = False;                                              //shutdown TP1 cycle
                          bModSL = false;                                            //verify ordermodify, then set to false
                          bTP2 = True;                                               //Open TP2 cycle 
                         }                              
                       }
                   }  
            }      
          }      
      }      

//------------------------------------------------------------------------------------

   void TP2MonitorRR()
      {
          if(bTP2==True)                                                                                 // after TP1 hit, Monitor for TP2
            {
             if(OrderType()==0)                                                                          //if its a buy order 
               {
                if(Bid>=TP2)                                                                             //if TP 2 is hit
                  {  
                   bTP = OrderClose(Ticket,iLots/2,Bid,0,Red);                                           //Close 1/2 order
                     if(bTP==True)                                                                       //if TP2 orderclose success
                        {
                         if(TakeProfit2==0)
                           {
                            Print("Closed 1/2 remaining order at TP2 @ 2:1 R/R.");                         //confirm TP 2 partial close                           
                           }
                         else
                           {
                            Print("Closed 1/2 remaing order at TP2.");
                           } 
 
                         ObjectDelete("TP2");                                                            //Delete SL ojbect lines
                         
                         bModSL = OrderModify(GetTicket(),dOpenPrice,NormalizeDouble(TP1,Digits),0,0);   //Modify order SL following first partial TP                         
                         
                         bTP  = false;                                                                   //Completed TP task for TP2 monitor
                         bTP2 = false;                                                                   //end TP2 cycle
                         
                         Print("Activating trailing stop function.");                         
                         bTP3 = true;                                                                    //Open TP3 monitor
                         bSLCheck = true;
                        }
                  }                
               }
               
             if(OrderType()==1)
               {
                if(Ask<=TP2)                                                                               //if TP 2 is hit
                  {
                   bTP = OrderClose(Ticket,iLots/2,Ask,0,Red);                                             //Close 1/2 order
                     if(bTP==True)                                                                         //if TP2 orderclose success
                        {
                         if(TakeProfit2==0)
                           {
                            Print("Closed 1/2 remaining order at TP2 @ 2:1 R/R.");                         //confirm TP 2 partial close                           
                           }
                         else
                           {
                            Print("Closed 1/2 remaing order at TP2.");
                           } 

                         ObjectDelete("TP2");                                                               //Delete SL ojbect lines
                         
                         bModSL = OrderModify(GetTicket(),dOpenPrice,NormalizeDouble(TP1,Digits),0,0);     //Modify order SL following first partial TP
                       
                         bTP  = false;                                                                      //Completed TP task for TP2 monitor
                         bTP2 = false;                                                                      //end TP2 cycle
                         
                         Print("Activating trailing stop function.");
                         bTP3 = true;                                                                       //Open TP3 monitor
                         bSLCheck = true;
                        }
                  }                 
               }
            }      
      }
        
    
      
//--------6-----------------------------------------------------------    
      
   void TrSL()
      {
          if(bTP3==True)                                                                         //After 2 hard exits, trail remaining 1/3
            {
              if(Y==0)return;                                                                    //wait until next tick to check trailing stop for new ticket #
              if(OrderType()==0)
               {
                if(TrailingStop>0)                
                {                                
                 dTrSL   = Bid-dPoints*TrailingStop;                                             //Calculate Target SL
                 dTrDiff = dTrSL - OrderStopLoss();                                              //Difference of target SL and current SL
                 
                 if(bSLCheck==true && dTrSL<OrderStopLoss()) return;                             //wait for TrSL value to pass current SL value before trailing
                 bSLCheck=false;                                                                 //stop SL check, TrSL value already passed previous set SL value
                 
                 if(OrderStopLoss()<dTrSL && dTrDiff > dPoints)                                  //if current active SL is less than target TrSL & diff. is greater than 1 pip                                 
                   {
                    OrderModify(GetTicket(),0,NormalizeDouble(dTrSL,Digits),0,0);                //Modify the order
                   }
                }                
               }             
               
              if(OrderType()==1)  
               {
                if(TrailingStop>0)                
                {                                  
                 dTrSL   = Ask+dPoints*TrailingStop;                                               //Calculate Target SL
                 dTrDiff = OrderStopLoss() - dTrSL;                                                //Difference of target SL and current SL
                 
                 if(bSLCheck==true && dTrSL>OrderStopLoss()) return;                                //wait for TrSL value to pass current SL value before trailing
                 bSLCheck=false;                 
            
                 if(OrderStopLoss()>dTrSL && dTrDiff > dPoints)                                    //if current active SL is higher than target TrSL & diff. is greater than 1 pip                                 
                   {
                    OrderModify(GetTicket(),0,NormalizeDouble(dTrSL,Digits),0,0);                     //Modify the order
                   }
                }               
               }
            }       
      } 

